﻿using System.Collections.Generic;

namespace EnvelopeCreatorProject.Models
{
    public class EnvelopeSettings
    {
        public bool AllowMarkup { get; set; }
        public bool AllowReassign { get; set; }
        public bool AllowRecipientRecursion { get; set; }
        public bool Asynchronous { get; set; }
        public bool AuthoritativeCopy { get; set; }
        public bool AutoNavigation { get; set; }
        public string BrandId { get; set; }
        public bool BrandLock { get; set; }
        public bool EnableWetSign { get; set; }
        public bool MessageLock { get; set; }
        public bool RecipientsLock { get; set; }
        public SignLocation SigningLocation { get; set; }
        public string TransactionId { get; set; }
        public bool UseDisclosure { get; set; }
        public bool EnforceSignerVisibility { get; set; }
        public DocusignNotificationSettings Notification { get; set; }
        public DocusignEmailSettings EmailSettings { get; set; }
        public DocusignCustomFields CustomFields { get; set; }
    }

    public class DocusignNotificationSettings
    {
        public bool UseAccountDefaults { get; set; }
        public DocusignNotificationReminder Reminders { get; set; }
        public DocusignNotificationExpiration Expirations { get; set; }

    }

    public class DocusignNotificationReminder
    {
        public bool ReminderEnabled { get; set; }
        public int ReminderDelay { get; set; }
        public int ReminderFrequency { get; set; }
    }

    public class DocusignNotificationExpiration
    {
        public bool ExpireEnabled { get; set; }
        public int ExpireAfter { get; set; }
        public int ExpireWarn { get; set; }
    }


    public enum SignLocation
    {
        Online = 0,
        InPerson = 1
    }

    public class DocusignCustomFields
    {
        public List<DocusignListCustomField> ListCustomFields { get; set; }
        public List<DocusignTextCustomField> TextCustomFields { get; set; }
    }

    public class DocusignListCustomField
    {
        public string Name { get; set; }
        public bool Required { get; set; }
        public bool Show { get; set; }
        public string Value { get; set; }
        public List<string> ListItems { get; set; }
    }

    public class DocusignTextCustomField
    {
        public string Name { get; set; }
        public bool Required { get; set; }
        public bool Show { get; set; }
        public string Value { get; set; }
    }

    public class DocusignEmailSettings
    {
        public string ReplyEmailAddressOverride { get; set; }
        public string ReplyEmailNameOverride { get; set; }
        public List<string> BccEmailAddresses { get; set; }
    }
}
